﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7
@EndOfDesignText@
'things to note
'the field names are case sensitive
Sub Class_Globals
	Public BANano As BANano
	Public const DB_BOOL As String = "BOOL"
	Public const DB_INT As String = "INT"
	Public const DB_STRING As String = "STRING"
	Public const DB_DATE As String = "DATE"
	Public const DB_CREATE As String = "CREATE"
	Public const DB_INSERT As String = "INSERT"
	Public const DB_UPDATE As String = "UPDATE"
	Public const DB_UPDATEALL As String = "UPDATEALL"
	Public const DB_SELECT As String = "SELECT"
	Public const DB_EXISTS As String = "EXISTS"
	Public const DB_CREATEINDEX As String = "CREATEINDEX"
	Public const DB_DELETE As String = "DELETE"
	Public alaSQL As BANanoSQL
	Private vDBName As String
	Private ToExecute As Int = 0 
	Private Executed As Int = 0
End Sub

'open the database
Public Sub Initialize(dbName As String)
	vDBName = dbName
	alaSQL.Open("SQL", dbName)
End Sub

'to insert a record, first lets see if its existing
Sub CheckFlight(fn As Int)
	Dim flights As Map = CreateMap("flightNo": fn)
	Dim sqlm As Map = SelectWhereSQLMap("flights", flights)
	Dim sql As String = sqlm.Get("sql")
	Dim values As List = sqlm.Get("values")
	Log(sql)
	Log(values)
	alaSQL.Execute(sql, values, DB_EXISTS)
End Sub

Sub DeleteFlight(fn As Int)
	'please note the operator =
	Dim flights As Map = CreateMap("flightNo =": fn)
	Dim sqlm As Map = DeleteWhereSQLMap("flights", flights)
	Dim sql As String = sqlm.Get("sql")
	Dim values As List = sqlm.Get("values")
	Log(sql)
	Log(values)
	alaSQL.Execute(sql, values, DB_DELETE)
End Sub

'the map should be the fieldname and unique parameter
'do not include the primary key, unique not implemented
Sub CreateIndexes(tblName As String, idxMap As Map)
	If idxMap.Size = 0 Then
		Log($"CreateIndexes: ${tblName} - idxMap map empty!"$)
		Return
	End If
	Dim iTot As Int = idxMap.Size - 1
	ToExecute = idxMap.Size
	Executed = 0
	Dim iCnt As Int
	For iCnt = 0 To iTot
		Dim idxName As String = idxMap.GetKeyAt(iCnt)
		Dim idxUnique As Boolean = idxMap.Get(idxName)
		Dim idxKey As String = $"${tblName}_${idxName}"$
		Dim qry As String = $"CREATE INDEX ${EscapeField(idxKey)} ON ${EscapeField(tblName)}(${EscapeField(idxName)})"$
		Log(qry)
		alaSQL.Execute(qry, Null, DB_CREATEINDEX)
	Next
End Sub

Sub CreateFlightsIndexes
	Dim flights As Map = CreateMap("fromCity": False,"toCity": False, "isInTheAir": False)
	CreateIndexes("flights", flights)
End Sub

Sub CreateFlightsTable
	'lets create a table to store data
	'flights (flightNo INT, fromCity STRING, toCity STRING, isInTheAir BOOL)
	Dim flights As Map
	flights.Initialize
	flights.Put("flightNo", DB_INT)
	flights.Put("fromCity", DB_STRING)
	flights.Put("toCity", DB_STRING)
	flights.Put("isInTheAir", DB_BOOL)
	Dim sql As String = CreateTableSQL("flights",flights,"flightNo")
	Log(sql)
	alaSQL.Execute(sql, Null, DB_CREATE)
End Sub

'should be specific to project
Sub InsertFlight(fn As Int)
	Dim flights As Map
	flights.Initialize
	flights.Put("flightNo", fn)
	flights.Put("fromCity", "Brussels")
	flights.Put("toCity", "Paris")
	flights.Put("isInTheAir", True)
	Dim sqlm As Map = InsertSQLMap("flights", flights)
	Dim sql As String = sqlm.Get("sql")
	Dim values As List = sqlm.Get("values")
	Log(sql)
	Log(values)
	alaSQL.Execute(sql, values, DB_INSERT)
End Sub

'should be specific to project
Sub UpdateFlight(fn As Int)
	'fields to update
	Dim flights As Map
	flights.Initialize
	flights.Put("fromCity", "Paris")
	flights.Put("toCity", "Brussels")
	flights.Put("isInTheAir", False)
	'select this one
	Dim wherem As Map
	wherem.Initialize 
	wherem.Put("flightNo", fn)
	Dim sqlm As Map = UpdateWhereSQLMap("flights", flights, wherem)
	Dim sql As String = sqlm.Get("sql")
	Dim values As List = sqlm.Get("values")
	Log(sql)
	Log(values)
	alaSQL.Execute(sql, values, DB_UPDATE)
End Sub

'update all flights
Sub UpdateAllFlights
	'fields to update
	Dim flights As Map
	flights.Initialize
	flights.Put("fromCity", "East London")
	flights.Put("toCity", "Israel")
	flights.Put("isInTheAir", True)
	Dim sqlm As Map = UpdateSQLMap("flights", flights)
	Dim sql As String = sqlm.Get("sql")
	Dim values As List = sqlm.Get("values")
	Log(sql)
	Log(values)
	alaSQL.Execute(sql, values, DB_UPDATEALL)
End Sub

'find a record flights
Sub SelectAFlight
	Dim flights As Map
	flights.Initialize
	flights.Put("flightNo", 1)
	flights.Put("fromCity", "East London")
	Dim sqlm As Map = SelectWhereSQLMap("flights", flights)
	Dim sql As String = sqlm.Get("sql")
	Dim values As List = sqlm.Get("values")
	Log(sql)
	Log(values)
	alaSQL.Execute(sql, values, DB_SELECT)
End Sub


Sub SQL_SQLOpened()
	Log("Database: " & vDBName & " opened successfully!")
	'lets create the flights table
	CreateFlightsTable		
End Sub

Sub SQL_SQLExecuteError(Tag As String, Reason As String)
	Log("ERROR for TAG:" & Tag & " Reason:" & Reason)
End Sub

Sub SQL_SQLExecuteResult(Tag As String, Result As List)
	Select Case Tag
		Case DB_CREATEINDEX
			'lets add indexes to the table
			Executed = Executed + 1
			Log(ToExecute)
			Log(Executed)
		Case DB_CREATE
			Log("Create Done!")
			'CreateFlightsIndexes
			'check the record existance first before you add it
			CheckFlight(1)
		Case DB_EXISTS
			Log("EXISTS DONE!")
			Log(Result.Size)
			Select Case Result.Size
			Case 0
				'record does not exist, add it
				InsertFlight(1)
			Case Else
				'record exists, update it
				UpdateFlight(1)
			End Select
		Case DB_INSERT
			Log("INSERT DONE!")
			UpdateFlight(1)
		Case DB_UPDATE
			Log("UPDATE DONE!")
			UpdateAllFlights
		Case DB_UPDATEALL
			Log("UPDATE ALL DONE!")
			SelectAFlight
		Case DB_SELECT
			Log("SELECT DONE!")
			Log(Result.Size)
			For Each recordm As Map In Result
				Log(recordm)
			Next
			DeleteFlight(1)
		Case DB_DELETE
			Log("DELETE DONE!")
	End Select
End Sub

Private Sub EscapeField(f As String) As String
	Return $"[${f}]"$
End Sub

'return a sql command to create the table
Sub CreateTableSQL(tblName As String, tblFields As Map, PK As String) As String
	If tblFields.Size = 0 Then
		Log($"CreateTableSQL: ${tblName} - tblFields map empty!"$)
		Return Null
	End If	
	Dim fldName As String
	Dim fldType As String
	Dim fldTot As Int
	Dim fldCnt As Int
	fldTot = tblFields.Size - 1
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("(")
	For fldCnt = 0 To fldTot
		fldName = tblFields.GetKeyAt(fldCnt)
		fldType = tblFields.Get(fldName)
		If fldCnt > 0 Then 
			sb.Append(", ")
		End If
		sb.Append(EscapeField(fldName))
		sb.Append(" ")
		sb.Append(fldType)
		If fldName.EqualsIgnoreCase(PK) Then 
			sb.Append(" PRIMARY KEY")
		End If		
	Next
	sb.Append(")")
	'define the qry to execute
	Dim query As String = "CREATE TABLE IF NOT EXISTS " & EscapeField(tblName) & " " & sb.ToString
	Return query
End Sub

'return a sql map to insert record to table. sql = query string, values = list of values
Sub InsertSQLMap(tblName As String, tblFields As Map) As Map
	If tblFields.Size = 0 Then
		Log($"InsertSQLMap: ${tblName} - tblFields map empty!"$)
		Return Null
	End If
	Dim sb As StringBuilder
	Dim columns As StringBuilder
	Dim values As StringBuilder
	Dim listOfValues As List
	Dim iCnt As Int
	Dim iTot As Int
	sb.Initialize
	columns.Initialize
	values.Initialize
	listOfValues.Initialize
	sb.Append($"INSERT INTO ${EscapeField(tblName)} ("$)
	iTot = tblFields.Size - 1
	For iCnt = 0 To iTot
		Dim col As String = tblFields.GetKeyAt(iCnt)
		Dim value As String = tblFields.Get(col)
		If iCnt > 0 Then
			columns.Append(", ")
			values.Append(", ")
		End If
		columns.Append(EscapeField(col))
		values.Append("?")
		listOfValues.Add(value)
	Next
	sb.Append(columns.ToString)
	sb.Append(") VALUES (")
	sb.Append(values.ToString)
	sb.Append(")")
	Dim m As Map
	m.Initialize
	m.Put("sql", sb.ToString)
	m.Put("values", listOfValues)
	Return m
End Sub

'return a sql to update record of table where one exists
Sub UpdateWhereSQLMap(tblName As String, tblFields As Map, tblWhere As Map) As Map
	If tblWhere.Size = 0 Then
		Log($"UpdateWhereSQLMap: ${tblName} - tblWhere map empty!"$)
		Return Null
	End If
	If tblFields.Size = 0 Then
		Log($"UpdateWhereSQLMap: ${tblName} - tblFields map empty!"$)
		Return Null
	End If
	Dim sb As StringBuilder
	Dim args As List
	sb.Initialize
	args.Initialize
	sb.Append($"UPDATE ${EscapeField(tblName)} SET "$)
	Dim i As Int
	Dim iTot As Int = tblFields.Size - 1
	For i = 0 To iTot
		Dim col As String = tblFields.GetKeyAt(i)
		Dim colvalue As String = tblFields.Get(col)
		sb.Append(col)
		If i <> iTot Then
			sb.Append("=?,")
		Else
			sb.Append("=?")
		End If
		args.Add(colvalue)
	Next
    sb.Append(" WHERE ")
	Dim iWhere As Int = tblWhere.Size - 1
	For i = 0 To iWhere
		If i > 0 Then
			sb.Append(" AND ")
		End If
		Dim colwhere As String = tblWhere.GetKeyAt(i)
		Dim colvalue As String = tblWhere.Get(colwhere)
		sb.Append(colwhere)
		sb.Append(" = ?")
		args.Add(colvalue)
	Next
	Dim m As Map
	m.Initialize
	m.Put("sql", sb.tostring)
	m.Put("values", args)
	Return m
End Sub

'return a sql to delete record of table where one exists
Sub DeleteWhereSQLMap(tblName As String, tblWhere As Map) As Map
	If tblWhere.Size = 0 Then
		Log($"DeleteWhereSQLMap: ${tblName} - tblWhere map empty!"$)
		Return Null
	End If
	Dim sb As StringBuilder
	Dim args As List
	sb.Initialize
	args.Initialize
	sb.Append($"DELETE FROM ${EscapeField(tblName)} WHERE "$)
	Dim i As Int
	Dim iWhere As Int = tblWhere.Size - 1
	For i = 0 To iWhere
		If i > 0 Then
			sb.Append(" AND ")
		End If
		Dim colwhere As String = tblWhere.GetKeyAt(i)
		Dim colvalue As String = tblWhere.Get(colwhere)
		sb.Append(colwhere)
		sb.Append(" ? ")
		args.Add(colvalue)
	Next
	Dim m As Map
	m.Initialize
	m.Put("sql", sb.tostring)
	m.Put("values", args)
	Return m
End Sub

'return a sql to update all records of table
Sub UpdateSQLMap(tblName As String, tblFields As Map) As Map
	If tblFields.Size = 0 Then
		Log($"UpdateSQLMap: ${tblName} - tblFields map empty!"$)
		Return Null
	End If
	Dim sb As StringBuilder
	Dim args As List
	sb.Initialize
	args.Initialize
	sb.Append($"UPDATE ${EscapeField(tblName)} SET "$)
	Dim i As Int
	Dim iTot As Int = tblFields.Size - 1
	For i = 0 To iTot
		Dim col As String = tblFields.GetKeyAt(i)
		Dim colvalue As String = tblFields.Get(col)
		sb.Append(col)
		If i <> iTot Then
			sb.Append("=?,")
		Else
			sb.Append("=?")
		End If
		args.Add(colvalue)
	Next
    Dim m As Map
	m.Initialize
	m.Put("sql", sb.tostring)
	m.Put("values", args)
	Return m
End Sub

'return a sql to select record of table where one exists
Sub SelectWhereSQLMap(tblName As String, tblWhere As Map) As Map
	If tblWhere.Size = 0 Then
		Log($"SelectWhereSQLMap: ${tblName} - tblWhere map empty!"$)
		Return Null
	End If
	Dim sb As StringBuilder
	Dim args As List
	sb.Initialize
	args.Initialize
	sb.Append($"SELECT * FROM ${EscapeField(tblName)} WHERE "$)
	Dim i As Int
	Dim iWhere As Int = tblWhere.Size - 1
	For i = 0 To iWhere
		If i > 0 Then
			sb.Append(" AND ")
		End If
		Dim colwhere As String = tblWhere.GetKeyAt(i)
		Dim colvalue As String = tblWhere.Get(colwhere)
		sb.Append(colwhere)
		sb.Append(" = ?")
		args.Add(colvalue)
	Next
	Dim m As Map
	m.Initialize
	m.Put("sql", sb.tostring)
	m.Put("values", args)
	Return m
End Sub

